import 'dart:ffi';
import 'dart:typed_data';

import 'package:benchmark_harness/benchmark_harness.dart';
import 'package:ffi_helper/ffi_helper.dart';

final buffer = Array<Uint8>(10);
final fill = Uint8List.fromList(const [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]);

class CachedList extends BenchmarkBase {
  CachedList() : super('CachedList');
  @override
  void run() {
    buffer.asTypedList().setAll(0, fill);
  }
}

class UncachedList extends BenchmarkBase {
  UncachedList() : super('UncachedList');
  @override
  void run() {
    buffer.ptr.asTypedList(10).setAll(0, fill);
  }
}

class ConstantList extends BenchmarkBase {
  final view = buffer.ptr.asTypedList(10);

  ConstantList() : super('ConstantList');
  @override
  void run() {
    view.setAll(0, fill);
  }
}

void main() {
  CachedList().report();
  UncachedList().report();
  ConstantList().report();
}
